;
;	Field!
;	Copyright (C) 1991 D Roland
;
; Field! is a interesting little game written for the S-Chip V1.1 interpreter
; which is available from several sources.
;
; To play press FIELD and then press SCHIP or however you have named your
; S-CHIP V1.1 interpreter.
;
; A title screen will appear proclaiming the game name(and my name) with quite
; a bit of animation.  The amount of title screen animation explains for its
; rather large size for a S-CHIP game of 700 some odd bytes.  However, it is
; still amazing to me that a game(as simple as this can be written in so few
; bytes!)
;
; To play press the "." key during the title sequence, you may have to hold it
; down for a second or to (since I don't check keypresses between every single
; frame of animation.)
;
; The screen will then appear like:
;  _________________________
; |#                       #|
; |                         |   .----ASTEROIDS
; |#                        |   |
; |                        #<---'
; |                         |
; |#_______________________#|
;
; The keys are now defined as:
;
; 1 - Apply thrust to the left ( so you move right! )
; 2 - Apply thrust to the right ( so you move left! )
; / - Move up
; * - Move Down
; 7 - Abandon Game and return to the Title Screen
;
; Now once the game is going.(you must apply thrust to actually start.)
; The screen appears like this.
;  _________________________
; |#         #             #|
; |     +-           #      |
; |#    ^          #        |
; |  #  |   #              #|
; |     |           #       |
; |#____|__________________#|
;       |
;      You
;
;
; Now your on your on... Just don't hit anything.
;
; Your score is based on how long you last, actually it is more of a rating
; than a score, and it is revealed to you by the OWL on the Title screen.
;
; 0-F (In HEX cause that was easier to do, and since this is my FIRST chip
; program, I think you can be happy with that, anyway it will probably only be
; by an act of God that you make it very far.)
;
; Hope you enjoy!
;
; Let me know if you like it, or if there are any bugs, or you want more.
; I would greatly appreciate hearing from any of you HP48sx whizes.
; This horizontal scrolling looks tremendously like DEFENDER and perhaps
; that is where this program will go!.
;
;
;                 ** Notes about this program **
; If you think the game is to slow, let me know it is loaded with delays, it
; goes so fast you can't see a thing if you take out the delays. (Idea...
; release version with variable speed control.)
;
; Since I don't have a PC and didn't feel like downloading CHIPPER(source and
; stuff) I had to write my own PSEUDO-COMPILER/ASSEMBLER/LINKER.  I did this and
; wrote this game to test it yesterday(but what a long day it was!)
;
; The main reason it is just a PSEUDO-COMPILER is that the code generated by
; BISON on one of the Fish Disks just won't compile! So the Parser is integrated
; into the Scanner(thanks FLEX.)  Since it is a two step Compile(SYMTAB Build,
; OBJ Generation) a linker was needed to create the S-CHIP V1.1 executable.
; All these are now working in one 20K executable Amiga Program.
; This is all written based solely on the CHIP48 docs (scanty at best) and I'm
; still not quite sure how to do everything.
;
; I'll try to post this program later today, once I write the DOCS.
;
; I think you folks should like it, because the source doesn't look like
; assembler.
;
;
; Anyway, thanks go to Andreas Gustafsson for the excellent!!! chip interpreter,
; and to Erik Bryntse for his modifications that resulted in the even more
; excellent! Super Chip V1.1!
;
; *********************** DISCLAIMER ******************************************
; I, Al Roland, being of sound body and mind, and poor grammatical and spelling
; ability, make no warranties expressed or implied to anyone no matter how
; unsound their body and mind are regarding the included software, and the
; damages that might result to those unsound bodies and minds, when they misuse
; this software on their calculator. I also will not be held responsible for
; a grade drop when you play this game in class and forget to take notes.
; And, blah blah blah....
;
;                                 Al Roland
;                              711 Cary Drive
;                             Auburn, Al 36830
;
;                           droland@eng.auburn.edu
;
; oh yeah...I release this as FREEWARE, play it, and enjoy it. But
; don't modify, mutilate, or spindle this program unless I know about
; (and approve) it.
;                             (c)1991 Al Roland
;
;
	.title	"Field version 1.0",
		"Copyright (C) 1991 Al Roland"
	.xref	on
;
	jump	start
	.byte	10
	.ascii	"Field version 1.0"
	.byte	10
	.ascii	"Copyright (C) 1991 Al Roland"
	.byte	10
	.align
start:
	high
L1:
	load	v1, 42
	load	v2, 1
	load	i, L40
	xdraw	v1, v2
	load	v1, 58
	load	i, L41
	xdraw	v1, v2
	load	v1, 74
	load	i, L42
	xdraw	v1, v2
	load	v1, 64
	load	v2, 48
	load	i, L38
	xdraw	v1, v2
	load	v1, 48
	load	i, L37
	xdraw	v1, v2
	load	v2, 32
	load	v3, 48
	load	v4, 32
	load	vE, 1
	load	vD, 3
	load	i, L31
	xdraw	v1, v2
	load	v1, 64
	load	i, L32
	xdraw	v1, v2
	load	v5, 255
L2:
	sub	v5, vE
	skip.eq	v5, 0
	jump	L2
	load	v5, 255
L3:
	sub	v5, vE
	skip.eq	v5, 0
	jump	L3
	load	v1, 48
	load	i, L31
	xdraw	v1, v2
	load	i, L33
	xdraw	v1, v2
	load	v5, 240
L4:
	sub	v5, vE
	skip.eq	v5, 0
	jump	L4
	xdraw	v1, v2
	load	i, L34
	xdraw	v1, v2
	sub	v3, vD
	sub	v4, vD
	load	i, L36
	xdraw	v3, v4
	load	v5, 240
L5:
	sub	v5, vE
	skip.eq	v5, 0
	jump	L5
	xdraw	v3, v4
L6:
	sub	v3, vD
	sub	v4, vD
	load	i, L35
	xdraw	v3, v4
	load	v5, 240
L7:
	sub	v5, vE
	skip.eq	v5, 0
	jump	L7
	xdraw	v3, v4
	sub	v3, vD
	sub	v4, vD
	load	i, L36
	xdraw	v3, v4
	load	v5, 240
L8:
	sub	v5, vE
	skip.eq	v5, 0
	jump	L8
	xdraw	v3, v4
	load	v2, 0
	skip.eq	v2, key
	jump	L6
	clear
	load	v3, 1
	load	v1, 1
	load	v2, 7
	load	v9, 32
	load	vA, 15
	load	v5, 1
	load	vB, 122
	load	vE, 1
	load	vD, 0
	load	v7, 0
	load	i, L30
L9:
	add	v7, 1
	skip.ne	v7, 192
	jump	L18
L10:
	load	v2, 1
	skip.ne	v2, key
	jump	L14
	load	v2, 2
	skip.ne	v2, key
	jump	L15
	load	v2, 4
	skip.ne	v2, key
	jump	L16
	load	v2, 5
	skip.ne	v2, key
	jump	L17
	load	v2, 7
	skip.ne	v2, key
	jump	L26
	load	v2, 8
	skip.ne	v2, key
	jump	L27
	load	v2, 12
	skip.ne	v2, key
	jump	L19
	load	v2, 13
	skip.ne	v2, key
	jump	L20
L11:
	skip.ne	vC, 1
	jump	L26
	skip.ne	vC, 2
	jump	L27
L12:
	load	v2, 112
L13:
	sub	v2, v3
	skip.eq	v2, 0
	jump	L13
	load	i, L28
	;rnd	v1, 58
	rnd	v1, 63
	load	vE, 64
	sub	vE, v1
	draw	v5, vE, 4
	draw	vB, vE, 4
	skip.ne	vC, 1
	jump	L21
	skip.ne	vC, 2
	jump	L22
	jump	L9
L14:
	load	v3, 1
	jump	L11
L15:
	load	v3, 2
	jump	L11
L16:
	load	v3, 4
	jump	L11
L17:
	load	v3, 8
	jump	L11
L18:
	add	vD, 1
	load	v7, 0
	jump	L10
L19:
	load	vE, 1
	sub	vA, vE
	jump	L11
L20:
	load	vE, 1
	add	vA, 1
	jump	L11
L21:
	load	i, L29
	draw	v9, vA, 3
	jump	L9
L22:
	load	i, L30
	draw	v9, vA, 3
	jump	L9
L23:
	load	v5, 8
	sub	v9, v5
	sub	vA, v5
	load	i, L43
	xdraw	v9, vA
	load	v5, 240
	load	vE, 1
L24:
	sub	v5, vE
	skip.eq	v5, 0
	jump	L24
	load	i, L44
	xdraw	v9, vA
	load	v5, 255
	load	vE, 1
L25:
	sub	v5, vE
	skip.eq	v5, 0
	jump	L25
	clear
	load	v1, 44
	load	v2, 16
	load	i, L39
	xdraw	v1, v2
	load	v1, 50
	load	v2, 37
	hex	vD
	draw	v1, v2, 5
	jump	L1
L26:
	scleft
	load	i, L29
	draw	v9, vA, 3
	skip.ne	vF, 1
	jump	L23
	load	vC, 1
	jump	L12
L27:
	scright
	load	i, L30
	draw	v9, vA, 3
	skip.ne	vF, 1
	jump	L23
	load	vC, 2
	jump	L12
L28:
	.pic	" ** *** ",
		"********",
		" ****** ",
		"  **  **"
L29:
	.pic	"***     ",
		" *******",
		"***     ",
		"        "
L30:
	.pic	"     ***",
		"******* ",
		"     ***",
		"*  **  *"
L31:
	.xpic	"                ",
		"  *     *     **",
		"  **   **    ** ",
		" *********   ***",
		" *  * *  *   ** ",
		" **** ****   ** ",
		"  *******       ",
		" * ***** *    **",
		"***********  *  ",
		"** ***** **   **",
		"***********     ",
		"** ** ** **     ",
		"* * * * * *   **",
		" ** * * **      ",
		"*** * * ********",
		"** * * * *******"
L32:
	.xpic	"                ",
		"**   **         ",
		" **  **         ",
		"***  **         ",
		" **  **         ",
		" **  *****      ",
		"                ",
		"**       **     ",
		"        *    *  ",
		"*   **  *   *** ",
		" * *  * **   *  ",
		" * *  * *    *  ",
		"*   **  *     **",
		"                ",
		"****************",
		"****************"
L33:
	.xpic	"     *          ",
		"   ****       **",
		"  ** ****    ** ",
		" ********    ***",
		"    ******   ** ",
		"     *** *** ** ",
		"    *********   ",
		"    ****** ** **",
		"     *********  ",
		"      ***** ****",
		"       *** *****",
		"        *  *****",
		"            ****",
		"       *     ***",
		"****************",
		"******** *******"
L34:
	.xpic	"                ",
		"              **",
		"             ** ",
		"             ***",
		"             ** ",
		"             ** ",
		"                ",
		"              **",
		"             *  ",
		"              **",
		"                ",
		"                ",
		"              **",
		"                ",
		"****************",
		"******** *******"
L35:
	.xpic	"     *          ",
		"   ****         ",
		"  ** ****       ",
		" ********       ",
		"    ******      ",
		"     *** ***    ",
		"    *********   ",
		"    ****** **   ",
		"     ********   ",
		"      ***** *** ",
		"       *** *****",
		"        *  *****",
		"         *  ****",
		"         **  ***",
		"              **",
		"                "
L36:
	.xpic	"   *            ",
		"  ****      *** ",
		" * **** * ******",
		"****************",
		"  **************",
		"    ******** ***",
		"     ******** **",
		"     ********  *",
		"      *******   ",
		"       *******  ",
		"        ** **** ",
		"        *  **** ",
		"         * *****",
		"            ****",
		"            ****",
		"                "
L37:
	.xpic	"  *  *    **    ",
		" * * *    * *   ",
		" * * *    **    ",
		" *** *    * *  *",
		" * * *    * * * ",
		" * * *    * *  *",
		"                ",
		" * *            ",
		" * * *  *       ",
		" ***   ****     ",
		" * * *  *       ",
		" * * *  *     **",
		" * * *   *    **",
		"                ",
		"                ",
		"                "
L38:
	.xpic	"  *           * ",
		"  *           * ",
		"  *           * ",
		"  *  ** **   ** ",
		"* * * * * * * * ",
		"  *  ** * *  ** ",
		"                ",
		" ***     **     ",
		"  *     * *     ",
		"  *  *  *    *  ",
		"  * * * * * * * ",
		"  * * * * * * * ",
		"  *  *   **  *  ",
		"                ",
		"                ",
		"                "
L39:
	.xpic	"   * *          ",
		"   * *          ",
		"    *   *  * *  ",
		"    *  * * * *  ",
		"    *   *   *   ",
		"                ",
		"**   *  *** *** ",
		"* * * *  *  *   ",
		"**  ***  *  *** ",
		"* * * *  *  *   ",
		"* * * *  *  *   ",
		"* * * *  *  *** ",
		"                ",
		"     ******     ",
		"      ****      ",
		"       **       "
L40:
	.xpic	"                ",
		"******** ****** ",
		"******** ****** ",
		"***        **   ",
		"***        **   ",
		"***        **   ",
		"******     **   ",
		"******     **   ",
		"***        **   ",
		"***        **   ",
		"***        **   ",
		"***        **   ",
		"***      ****** ",
		"***      ****** ",
		"                ",
		"                "
L41:
	.xpic	"                ",
		"******** ***    ",
		"******** ***    ",
		"***      ***    ",
		"***      ***    ",
		"***      ***    ",
		"******   ***    ",
		"******   ***    ",
		"***      ***    ",
		"***      ***    ",
		"***      ***    ",
		"***      ***    ",
		"******** ****** ",
		"******** ****** ",
		"                ",
		"                "
L42:
	.xpic	"                ",
		"*****       *   ",
		"*******    ***  ",
		"***  ***  ***** ",
		"***  ***  ***** ",
		"***  ***  ***** ",
		"***  ***  ***** ",
		"***  ***   ***  ",
		"***  ***   ***  ",
		"***  ***   ***  ",
		"***  ***    *   ",
		"***  ***        ",
		"*******    ***  ",
		"*****      ***  ",
		"                ",
		"                "
L43:
	.xpic	"              * ",
		"   *        **  ",
		"    *      * *  ",
		"    *** **      ",
		"     * ** *     ",
		"     **    ***  ",
		"   ** *   *  *  ",
		" **** * *  *    ",
		"**     **** *   ",
		"      *    **   ",
		"     * *    *   ",
		"    **     *    ",
		"   *            ",
		"                ",
		"                ",
		"                "
L44:
	.xpic	"**    **      * ",
		"  **   **   **  ",
		"    *  * * * *  ",
		"    *** **   *  ",
		" *** * ** ***  *",
		"   ****    ***  ",
		"   ** *   ***** ",
		" **** * *  *  **",
		"***    **** *  *",
		"  *   *    **  *",
		"     * *    *   ",
		" *  **     * *  ",
		"  **        * * ",
		"   ** **  **  * ",
		"   * *    **  * ",
		"  *            *"
